/*
 * Copyright (c) 2018, UAB 8Devices. All rights reserved.
 */

#ifndef _8192CD_AWDS_H_
#define _8192CD_AWDS_H_

#ifdef MBSSID
#define GET_PRIV(priv, vap_idx) \
	((GET_ROOT((priv))->pmib->miscEntry.vap_enable && ((vap_idx) >= 0)) ? \
	 GET_ROOT((priv))->pvap_priv[(vap_idx)] : (priv))
#else
#define GET_PRIV(priv, vap_idx) (priv)
#endif

#define RTL8192CD_AWDS_ENABLE(priv) \
	(GET_MIB((priv))->dot11OperationEntry.awds_enable = 1)
#define RTL8192CD_AWDS_DISABLE(priv) \
	(GET_MIB((priv))->dot11OperationEntry.awds_enable = 0)
#define RTL8192CD_IS_AWDS_ENABLED(priv) \
	(GET_MIB((priv))->dot11OperationEntry.awds_enable)

#define RTL8192CD_STAT_AWDS_ENABLE(priv, pstat)	\
	((pstat)->state |= WIFI_AWDS)
#define RTL8192CD_STAT_AWDS_DISABLE(priv, pstat) \
	((pstat)->state &= !WIFI_AWDS)
#define RTL8192CD_STAT_IS_AWDS_ENABLED(priv, pstat) \
	((pstat)->state & WIFI_AWDS)

int rtl8192cd_init_awds(struct rtl8192cd_priv *priv);
void rtl8192cd_deinit_awds(struct rtl8192cd_priv *priv);
void rtl8192cd_open_awds(struct rtl8192cd_priv *priv);
void rtl8192cd_close_awds(struct rtl8192cd_priv *priv);

struct stat_info *rtl8192cd_get_stainfo_awds(struct rtl8192cd_priv *priv,
					     const unsigned char *hwaddr);
void rtl8192cd_release_stainfo_awds(struct rtl8192cd_priv *priv,
				    struct stat_info *pstat);
void rtl8192cd_stat_awds_enable(struct rtl8192cd_priv *priv,
				struct stat_info *pstat);
int rtl8192cd_is_awds_ap(struct rtl8192cd_priv *priv,
			 struct rx_frinfo *pfrinfo);

#ifdef MBSSID
int rtl8192cd_rx_dispatch_awds(struct rtl8192cd_priv *priv,
			       struct rx_frinfo *pfrinfo, int vap_idx);
#else
int rtl8192cd_rx_dispatch_awds(struct rtl8192cd_priv *priv,
			       struct rx_frinfo *pfrinfo);
#endif
int rtl8192cd_xmit_awds_mcast(struct rtl8192cd_priv *priv, struct sk_buff *skb);
void rtl8192cd_xmit_awds_ucast_unknown(struct rtl8192cd_priv *priv,
				       struct sk_buff *skb);
void issue_4addr_NullData(struct rtl8192cd_priv *priv, unsigned char *da);

int MDL_INIT rtl8192cd_awds_init(void);
void MDL_EXIT rtl8192cd_awds_exit(void);

#endif /* _8192CD_AWDS_H_ */
