/*
 * Copyright (c) 2018, UAB 8Devices. All rights reserved.
 */

#ifndef _AWDS_H
#define _AWDS_H

enum awds_fdb_action {
	AWDS_FDB_ADD,
	AWDS_FDB_REMOVE,
	AWDS_FDB_CHANGE
};

struct awds_fdb;

struct awds_fdb *awds_fdb_create(void);
void awds_fdb_release(struct awds_fdb *fdb);
void awds_fdb_set_notify(struct awds_fdb *fdb,
			 void (*notify)(void *src, const u8 *addr,
					enum awds_fdb_action action,
					void *data),
			 void *data);
void awds_fdb_enable_gc(struct awds_fdb *fdb);
void awds_fdb_disable_gc(struct awds_fdb *fdb);

void *awds_fdb_lookup(struct awds_fdb *fdb, const u8 *addr);
void awds_fdb_update(struct awds_fdb *fdb, void *src, const u8 *addr);
void awds_fdb_flush(struct awds_fdb *fdb, void *src);

int __init awds_init(void);
void __exit awds_exit(void);

#endif /* _AWDS_H */
